(((kind "manual-section") (section-title "Organization of photos") (section-body ((ast "p" ("A LAML photo show is directory of films. Each film is a directory itself. Films cannot be nested into each other; Thus
                the films obey a flat organization within the top-level photo show directory. There may, however, be subdirs of the photo show directory
                with other photo shows directories (recursive orgnization). As of now, no linking is provided to these.") () double xhtml10-transitional) (ast "p" ("The directory corresponding to a film contains a flat list of jpg files, with arbitrary names.
                   To use the LAML photo show generator you should put a LAML file side-by-side with the photos, which describes the 
                   properties of the photo show, as related to the current film. This reference manual documents how this LAML is made.
                   To make things easy, use the Emacs command M-x make-laml-photo-show (found in 'Tools>LAML>Make new photo show...') for this.") () double xhtml10-transitional) (ast "p" ("Thus, the typical directory and file organization is like the following:") () double xhtml10-transitional) (ast "div" ((ast "pre" ("process-all-films.laml
index.html
Film1
  1.jpg
  2.jpg
  3.jpg
  make-show.laml
  index.html
  html
   1.html
   ...
  internal
   film-description-entry.lsp
   photo-ast.lsp
   photo-list
Film2
  1.jpg
  2.jpg
  3.jpg
  index.html
  make-show.laml
  html
   1.html
   ...
  internal
   film-description-entry.lsp
   photo-ast.lsp
   photo-list
Film3
  4.jpg
  5.jpg
  6.jpg
  index.html
  make-show.laml
  html
   1.html
   ...
  internal
   film-description-entry.lsp
   photo-ast.lsp
   photo-list") () double xhtml10-transitional)) (css:margin-left "20") double xhtml10-transitional) (ast "p" ("You are supposed to make to top level directory and
      the film directories. The directory names are arbitrary. The jpg files are created by the software that transfers photos from your digital camera. You write
      the make-show.laml files with your text editor - Emacs, for instance. The name of this file is arbitrary, but you should use the laml extension.
      The LAML photo show generator makes the remaining files and directories. - Noticed the file process-all-films.laml in the root which, when processed,
      regenerates the photo shows for all (already once processed) films; This laml file is made automatically the first to you process one of the films.") () double xhtml10-transitional) (ast "p" ("You can use the LAML photo show generator to make collections of photos from different directories, without copying any photo.
      To do so, make a film directory without jpg files, and address individual photos in arbitrary films from there. LAML makes it
      easy to do so, because you can copy the necessary photo clauses from your browser into the text editor. The names of the
      photos are linked to the appropriate photo clauses.") () double xhtml10-transitional)))) ((kind "manual-section") (section-title "The Top Level") (section-body "In this section we document the top level photo-show element, and not
                least its numerous attributes.")) ((kind "manual-page") (title "photo-show") (xml-in-laml-example-form (photo-show (quote time) "8" (quote background-color) "#123456" (photos-in-current-directory))) (description "The top level element which holds a number of attributes that affect the photo show of all pictures in a film.
               As constituents there is either a list of photo entries, or a directive to automatically collect the photos in the current directory.
              ") (attribute-descriptions (attribute-description "time" "The time in second each picture is show in automatically progressing shows. 
                                 This is a default value, which can be overwritten for each photo.") (attribute-description "background-color" "The background color of photo pages. As an example \"#000000\" represent black, like in HTML.
                                                The LAML function rgb-color-encoding is useful to give colors.") (attribute-description "text-color" "The color of the text in photo pages. As an example \"#ffffff\" represent white, like in HTML.
                                                The LAML function rgb-color-encoding is useful to give colors.") (attribute-description "home-path" "The path to the directory with all the film. Should always be \"../\" with the current and flat organization of the films.") (attribute-description "previous-film" "The to path of the previous film. The path is relative from the current directory. The path must have a trailing '/'.
                                             Example \"../Film1/\".") (attribute-description "next-film" "The path to the next film. The path is relative from the current directory. The path must have a trailing '/'.
                                             Example \"../Film2/\".") (attribute-description "before-first" "Determines what comes before the first photo in the film. 
                                            last-picture means 'cyclic show'.
                                            previous-film means that a link is made to the last picture in previous-film.
                                            none means that there is nothing before the first picture.
                                           ") (attribute-description "after-last" "Determins what comes after the last photo in the film.
                                          first-picture means 'cyclic show'.
                                          next-film means that a link is made to the first picture of the next-film.
                                          stop-page means that the photo show ends with a stop page.
                                          none means that thre is is nothing after the last picture.
                                         ") (attribute-description "transition" "The browser transition used when shifting from photo to phote during automatically progressing shows.
                                          Notice that blend only works in Internet Explorer from Microsoft.") (attribute-description "verbosity-level" "A number between 0 and 2 which controls the amount of messages given by the tool. 0 is minial and 2 is maximal.") (attribute-description "language" "The language of the fixed text generated by the tool") (attribute-description "html-mode" "The formatting of the HTML pages generated by the tool. pp means pretty printed, and it takes appr. the double amount of 
                                         disk space than raw. If you never read the HTML files - and why should you - you can use raw. ") (attribute-description "index-linking" "Determines the kind of linking used from a film page to the photos. 
                                            run means that the links go to automatically progressing pages.
                                            stop means that the links go to pages without automatically progress.
                                           ") (attribute-description "default-size" "Determines the size of the photos, as presented by the tool.
                                                    original means that the photos are presented directly, without enlarging or reducing them.
                                                    auto means that the photos are enlarged or reduced to make them fit with the real estate of the browser.
                                                    explicit means that we should use the witdh and height are given for each photo.
                                                   ") (attribute-description "default-orientation" "Controls the automatically enlarging or reduction, when auto is used for default-size.") (attribute-description "tabular-overview-dimension" "An integer such as 1, 2, 3 or 4 which determines the tabular layout of the overview pages.
                                                                  If, for instance, 3 is given, 9 photos are shown on each overview page.") (attribute-description "copy-film" "A boolean attribute that controls if the photos (the jpg files) are copied to the copy-destination directories.
                                                 Useful for photo management.") (attribute-description "copy-destination" "An absolute path on the your computer which defines the target directory of photo copying. Only 
                                                        releant is copy-film is true.") (attribute-description "" "")) (kind "manual-page") (content-model ("(" (((ast "a" ("title-of-show") (href "#title-of-show") double xhtml10-transitional) "") "," ((ast "a" ("upper-caption") (href "#upper-caption") double xhtml10-transitional) "") "," ((ast "a" ("lower-caption") (href "#lower-caption") double xhtml10-transitional) "") "," ("(" (((ast "a" ("photo-list") (href "#photo-list") double xhtml10-transitional) "") " | " ((ast "a" ("photos-in-current-directory") (href "#photos-in-current-directory") double xhtml10-transitional) "")) ")" "")) ")" "")) (attributes (attribute "time" "CDATA" "#REQUIRED") (attribute "background-color" "CDATA" "#IMPLIED") (attribute "text-color" "CDATA" "#IMPLIED") (attribute "home-path" "CDATA" "#IMPLIED") (attribute "previous-film" "CDATA" "#IMPLIED") (attribute "next-film" "CDATA" "#IMPLIED") (attribute "before-first" ("last-picture" "previous-film" "none") "last-picture") (attribute "after-last" ("first-picture" "next-film" "stop-page" "none") "first-picture") (attribute "transition" ("blend" "none") "none") (attribute "verbosity-level" "CDATA" "2") (attribute "language" ("danish" "english") "english") (attribute "html-mode" ("raw" "pp") "raw") (attribute "index-linking" ("run" "stop") "stop") (attribute "default-size" ("original" "auto" "explicit") "auto") (attribute "default-orientation" ("portrait" "landscape") "landscape") (attribute "portrait-percentage" "CDATA" "90") (attribute "landscape-percentage" "CDATA" "95") (attribute "tabular-overview-dimension" "CDATA" "3") (attribute "copy-film" ("true" "false") "false") (attribute "copy-destination" "CDATA" "#IMPLIED") (attribute "camera" "CDATA" "Canon-G3"))) ((kind "manual-page") (title "title-of-show") (xml-in-laml-example-form (title-of-show "The title")) (description "Determines the title (caption) of the current film") (kind "manual-page") (content-model "(#PCDATA)") (attributes)) ((kind "manual-page") (title "upper-caption") (attribute-descriptions (attribute-description "size" "The size of the upper caption. A number between 1 and 6.")) (xml-in-laml-example-form (upper-caption (quote size) "6" "Upper caption text")) (description "Defines the default upper caption of a photo page. Can be overruled by each photo element.") (kind "manual-page") (content-model "(#PCDATA)") (attributes (attribute "size" "CDATA" "#IMPLIED"))) ((kind "manual-page") (title "lower-caption") (attribute-descriptions (attribute-description "size" "The size of the lower caption. A number between 1 and 6.")) (xml-in-laml-example-form (lower-caption (quote size) "4" "Lower caption text")) (description "Defines the default lower caption of a photo page. Can be overruled by each photo element.") (kind "manual-page") (content-model "(#PCDATA)") (attributes (attribute "size" "CDATA" "#IMPLIED"))) ((kind "manual-page") (title "photos-in-current-directory") (xml-in-laml-example-form (photos-in-current-directory)) (description "Automatically forms a photo list of the photos in the current directory.
               This clause can be given instead of a photo list. It means that the tool automatically makes 
               a photo list of all the jpg files in the current directory. The sorting is done in a smart way, by
               taking the numeric part of the file names into account. Default properties are assigned to the photos. As an important practical observation, the tool
               will make a file photo-list in the internal directory, with a photo list. You can replace the (photos-in-current-directory) clause
               with this list, and thereby control the show in a much better way. ") (kind "manual-page") (content-model "EMPTY") (attributes)) ((kind "manual-page") (title "photo-list") (xml-in-laml-example-form (photo-list (photo (quote file) "1.jpt" (quote path) "Film1/"))) (description "The list of photos in the show. 
               Notice that the order of the photo elements in the photo-list controls the ordering of the photos in the show.
              ") (kind "manual-page") (content-model ("(" (((ast "a" ("photo") (href "#photo") double xhtml10-transitional) "*")) ")" "")) (attributes)) ((kind "manual-section") (section-title "The photo element") (section-body "In this section we document the photo element, which can be used to describe each photo in the show.
               ")) ((kind "manual-page") (title "photo") (attribute-descriptions (attribute-description "file" "The name of a photo file, either from the current directory (current film) or from another directory (another film).
                                 In the latter case, the path attribute must address the other film. 
                                 The name consist of the proper name and the file extension (jpg). For instance \"1.jpg\".  ") (attribute-description "path" "The path of the photo file, as given by the file attribute. The path is relative to the current directory.
                                      It must end with a '/'. Example: \"../Film3/\", where .. means the parent directory.") (attribute-description "time" "The time in second this photo is show in automatically progressing shows. 
                                 Overrules the time in the enclosing photo-show element.") (attribute-description "transition" "The browser transition used when shifting from this photo to the next.
                                            Notice that blend only works in Internet Explorer from Microsoft. Overrules the transition in photo-element.") (attribute-description "size" "Determines the size of this photo, as presented by the tool.
                                                    original means that the photo is presented directly, without enlarging or reducing it.
                                                    auto means that the photo is enlarged or reduced to make it fit with the real estate of the browser.
                                                    explicit means that we should use the width and height attribute of this photo.
                                                    Overrules the default value given in the enclosing photo-element.
                                                   ") (attribute-description "orientation" "Controls the automatically enlarging or reduction, when auto is used as size for this photo.") (attribute-description "width" "The width to be used for this photo. Use the value explicit for size if you give the width.
                                        Normally you will not want give both with and height.") (attribute-description "height" "The height to be used for this photo. Use the value explicit for size if you give the height. 
                                        Normally you will not want give both with and height.")) (xml-in-laml-example-form (photo (quote file) "1.jpg" (quote path) "../Film3/")) (description "Defines the characteristics of each presented photo in the show. Some of the attributes overrules the default attributes given in the photo-show element.") (kind "manual-page") (content-model ("(" (((ast "a" ("upper-caption") (href "#upper-caption") double xhtml10-transitional) "?") "," ((ast "a" ("lower-caption") (href "#lower-caption") double xhtml10-transitional) "?")) ")" "")) (attributes (attribute "file" "CDATA" "#REQUIRED") (attribute "path" "CDATA" "") (attribute "time" "CDATA" "#IMPLIED") (attribute "transition" ("blend" "none") "none") (attribute "size" ("original" "auto" "explicit") "auto") (attribute "orientation" ("portrait" "landscape") "landscape") (attribute "width" "CDATA" "#IMPLIED") (attribute "height" "CDATA" "#IMPLIED"))) ((kind "manual-section") (section-title "Examples") (section-body ((ast "p" ("In this section we show examples of LAML files.") () double xhtml10-transitional) (ast "p" ("The first file is similar to the file produced by the Emacs command M-x M-x make-laml-photo-show:") () double xhtml10-transitional) (ast "div" ((ast "pre" ("(load (string-append laml-dir \"laml.scm\"))
(laml-style \"xml-in-laml/photo-show/photo-show\")

(define photo-show-title \"Example\")

(photo-show
  'language \"danish\"                                       ; danish or english
  'time \"3\"
  'background-color (rgb-color-encoding black)             ; color string, like \"#123456\"
  'text-color (rgb-color-encoding white)                   ; color string, like \"#123456\"
  'home-path \"../\"
  'transition \"none\"                                       ; none or blend
  'tabular-overview-dimension \"3\"                          

  'previous-film \"../Film1/\"
  'before-first \"previous-film\"                            ; last-picture, previous-film, none
  'next-film \"../Film3/\"
  'after-last \"next-film\"                                  ; first-picture, next-film, stop-page, none

  'index-linking \"stop\"                                    ; run or stop
  'default-size \"auto\"                                     ; original, auto, explicit
  'default-orientation \"landscape\"                         ; portrait or landscape

  'verbosity-level \"2\"                                     ; 0, 1, 2


  (title-of-show photo-show-title)
  (upper-caption 'size \"6\" photo-show-title)
  (lower-caption 'size \"4\" \"\")

  (photos-in-current-directory)

)
") () double xhtml10-transitional)) (css:margin-left "10") double xhtml10-transitional) (ast "p" ("The purpose of the next laml file is to enumerate 'the best photos' in a large collection of films and photos:") () double xhtml10-transitional) (ast "div" ((ast "pre" ("(load (string-append laml-dir \"laml.scm\"))
(lib-load \"xml-in-laml/xml-in-laml.scm\")
(laml-style \"xml-in-laml/photo-show/photo-show\")

(photo-show
  'time \"8\"
  'language \"english\"
  'transition \"blend\"
  'html-mode \"pp\"
  'home-path \"../\"

  'tabular-overview-dimension \"3\"
  'before-first \"none\"
  'after-last \"stop-page\"

  (title-of-show \"My Best Photos\")
  (upper-caption 'size \"6\" \"\")
  (lower-caption 'size \"3\" \"\")
  

  (photo-list
    (photo 'time \"3\" 'path \"../Film34/\" 'file \"109_0957.JPG\" 'size \"auto\" (upper-caption 'size \"6\" \"\") )
    (photo 'time \"3\" 'path \"../Film34/\" 'file \"109_0960.JPG\" 'size \"auto\" (upper-caption 'size \"6\" \"\") ) 
    (photo 'time \"3\" 'path \"../Film34/\" 'file \"109_0968.JPG\" 'size \"auto\" (upper-caption 'size \"6\" \"\") )
    (photo 'time \"3\" 'path \"../Film34/\" 'file \"109_0974.JPG\" 'size \"auto\" (upper-caption 'size \"6\" \"\") )   
    (photo 'time \"3\" 'path \"../Film34/\" 'file \"109_0975.JPG\" 'size \"auto\" (upper-caption 'size \"6\" \"\") ) 
    (photo 'time \"3\" 'path \"../Film32/\" 'file \"109_0915.JPG\" 'size \"auto\" (upper-caption 'size \"6\" \"\") )

  )

)

") () double xhtml10-transitional)) (css:margin-left "10") double xhtml10-transitional)))))