(((kind "manual-section") (section-title "Preamble stuff") (section-body "The preamble stuff consist of forms which must occur first in a manual")) ((kind "manual-page") (title "set-manual-title") (form (set-manual-title title)) (description "Defines the manual title") (parameters (parameter "title" "the title of the manual (a string)")) (pre-condition "Must occur before any manual-section or manual-page form")) ((kind "manual-page") (title "set-manual-author") (form (set-manual-author . author-affiliation-list)) (description "Defines the author and affiliation information of this manual") (parameters (parameter "author-affiliation-list" "a list of strings, the first of which should be the author name. The rest can be address and affiliation information.
             The author name are embedded into a copyright notice")) (pre-condition "Must occur before any manual-section or manual-page form")) ((kind "manual-page") (title "set-manual-abstract") (form (set-manual-abstract abstract)) (description "Defines a manual abstract text") (parameters (parameter "abstract" "a string, the abstract text")) (pre-condition "Must occur before any manual-section or manual-page form")) ((kind "manual-page") (title "set-manual-name") (form (set-manual-name name)) (description "Defines the name of this manual. The result of the processing is written til  <kbd>name</kbd> .html. It is not necessary to use this form in implemetations, which can take the name from the Emacs buffer name") (parameters (parameter "name" "a name without path or extension information")) (pre-condition "Must occur before any manual-section or manual-page form")) ((kind "manual-page") (title "set-home-url") (form (set-home-url url)) (description "Define the home url to be referred to from the manual page, if any. Not in effect any more.") (parameters (parameter "url" "the internet address of the home page")) (pre-condition "Must occur before any manual-section or manual-page form")) ((kind "manual-page") (title "set-manual-master-index") (form (set-manual-master-index url)) (description "Define the url of the master index. The master index is a possibility in case several manual pages
               exist in the same directory, for instance for a system of libraries. The index must be generated
               manually, although there are functions for this purpose (see a separate section of this manual).
               If you do not want to refer to a master index, do not use this form, or pass #f as parameter.") (parameters (parameter "url" "the internet address of the index page (a string)- or #f")) (pre-condition "Must occur before any manual-section or manual-page form")) ((kind "manual-page") (title "laml-manual-stuff") (form laml-manual-stuff) (description "A boolean variable which controls if the generated manual is considered a laml manual. 
               For most users, this variable should be false.")) ((kind "manual-section") (section-title "Top level functions") (section-body "The important top level functions are manual-page and manual-section.
      These are the most important functions from a manual writer's perspective.")) ((kind "manual-page") (title "manual-page") (form (manual-page id . elements)) (description "Defines a manual entry.") (parameters (parameter "id" "A symbol identifying the manual page") (parameter "elements" "Zero, one or more title, form, pre-condition,
                           description, parameters, example, or misc elements"))) ((kind "manual-page") (title "manual-section") (form (manual-section . element)) (description "Defines a new section of a manual.
               The only forms allowed within a manual section are manual-title
               and manual-body") (parameters (parameter "elements" "a list of manual-title and manual-body forms"))) ((kind "manual-section") (section-title "Clauses of a manual page") (section-body "Here we describe the kernel of the manual page facility: the clauses that may appear within a manual-page form")) ((kind "manual-page") (title "title") (form (title title-string)) (pre-condition "Is only meaningful as a constituent of a manual page") (description "Sets the title of a manual entry. The title defines an anchor name, which can be used for cross reference purposes
                via  <a href = \"#internal-references\">internal-references</a>  ") (parameters (parameter "title-string" "The title, which normally is the first element of the calling form. Of type string"))) ((kind "manual-page") (title "form") (pre-condition "Is only meaningful as a constituent of a manual page") (form (form form-list)) (description "Shows the calling form of a manual entry") (parameters (parameter "form-list" "a proper or improper list of symbols"))) ((kind "manual-page") (title "xml-in-laml-example-form") (pre-condition "Is only meaningful as a constituent of a manual page") (form (xml-in-laml-example-form form-list)) (description "Shows a typical example of a calling form of an XML-in-LAML element.") (parameters (parameter "form-list" "a proper or improper list of symbols and strings")) (cross-references (internal-references "Similar function" "form")) (misc "Replaces a form constituent. Should never be used together with a form constituent.")) ((kind "manual-page") (title "pre-condition") (description "Defines the precondition of a manual entry") (pre-condition "Is only meaningful as a constituent of a manual page") (form (pre-condition condition-string)) (parameters (parameter "condition-string" "a string describing the precondition"))) ((kind "manual-page") (title "description") (form (description description-string)) (description "Describes the meaning of of a function. The first sentence goes into the overview table of the generated manual page. (A sentence is ended with a point and a space character)") (pre-condition "Is only meaningful as a constituent of a manual page") (parameters (parameter "description-string" "A string describing the meaning"))) ((kind "manual-page") (title "parameters") (form (parameters . parameter-list)) (description "Defines the parameters of a function") (pre-condition "Is only meaningful as a constituent of a manual page") (parameters (parameter "parameter-list" "a list of parameter forms"))) ((kind "manual-page") (title "parameter") (form (parameter name description)) (description "Defines the name and the meaning of a single parameter") (pre-condition "Is only meaningful as a constituent of parameters") (parameters (parameter "name" "the name of a parameter (a string)") (parameter "description" "the description of a parameter (a string)"))) ((kind "manual-page") (title "attribute-descriptions") (form (attribute-description . attribute-description-list)) (description "Defines and explains the attributes of an XML-in-LAML function") (pre-condition "Is only meaningful as a constituent of a manual page") (parameters (parameter "attribute-description-list" "a list of attribute-description clauses")) (cross-references (internal-references "Constituent form" "attribute-description")) (misc "Attribute descriptions are typically used together with automatic extraction of documention from
         parsed XML dtds.")) ((kind "manual-page") (title "attribute-description") (form (attribute-description "name" "description")) (description "Defines and explains a single attribute of an XML-in-LAML function") (pre-condition "Is only meaningful as a constituent of an attribute-descriptions clause") (parameters (parameter "name" "the name of an XML-in-LAML attribute") (parameter "description" "the description of an XML-in-LAML attribute")) (cross-references (internal-references "Enclosing form" "attribute-descriptions"))) ((kind "manual-page") (title "returns") (form (returns return-description)) (description "Explains the returned value of a function") (parameters (parameter "return-description" "The explanation of the returned value (a string)"))) ((kind "manual-page") (title "example") (form (example ex)) (description "Gives an example of the described function") (pre-condition "Is only meaningful as a constituent of a manual page") (parameters (parameter "ex" "the example"))) ((kind "manual-page") (title "cross-references") (form (cross-references . ref-list)) (description "Defines a list of cross reference items. Each item must be a reference form") (pre-condition "Is only meaningful as a constituent of a manual page") (parameters (parameter "ref-list" "The list of reference items"))) ((kind "manual-page") (title "reference") (form (reference cat anchor url)) (description "Makes a single reference to an Internet item") (parameters (parameter "cat" "A string describing the kind and category of the reference") (parameter "anchor" "The anchor text of the URL") (parameter "url" "The uniform resource locator of this reference")) (pre-condition "Must be found in a cross-references context")) ((kind "manual-page") (title "internal-references") (form (internal-references cat . ref-list)) (description "Make a list of references to other places in this manual.  All references are categorized as the first parameter describes") (parameters (parameter "cat" "the category of these references") (parameter "ref-list" "a list of internal references to other places in this manual. The type is list of string. Each string
                         refers to an anchor name (without #), which is defined for this manual. Each title of a manual-page gives rise to
                         an anchor name")) (pre-condition "Must be found in a cross-references context")) ((kind "manual-page") (title "misc") (form (misc m)) (description "describes miscelaneous information about this function") (pre-condition "Is only meaningful as a constituent of a manual page") (parameters (parameter "m" "the miscelanous information"))) ((kind "manual-page") (title "comment") (form (comment "internal-comment")) (description "Defines an internal comment. An internal comment typically reflects the status of the software, a thing to remember in the documentaiton, or another problem which should be alleviated") (parameters (parameter "internal-comment" "the text of the comment")) (pre-condition "Is only meaningful as a constituent of a manual page")) ((kind "manual-section") (section-title "Clauses of a manual section") (section-body "Here follows the two possible clauses of a manual section")) ((kind "manual-page") (title "section-title") (form (section-title title)) (description "Defines the title of a section") (parameters (parameter "title" "the title string")) (pre-condition "Must occur before any manual-section or manual-section form")) ((kind "manual-page") (title "section-body") (form (section-body body)) (description "Defines the body of a manual section") (parameters (parameter "body" "the text of a section body (a string)")) (pre-condition "Must occur before any manual-section or manual-section form")) ((kind "manual-section") (section-title "Other manual facilities") (section-body "Here follows some miscellaneous manual facilities")) ((kind "manual-page") (title "internal-ref") (form (internal-ref name)) (description "Returns a link to another place in the current manual document") (parameters (parameter "name" "the anchor name, such as a title of another manual entry (a string, without path and #)")) (pre-condition "Must occur 'within' a string of one of the manual clauses")) ((kind "manual-section") (section-title "Anchor names in a manual page") (section-body "It is useful to be able to refer to particular places and entries on a manual page. Therefore
     each manual page (each entry) has assigned an anchor name corresponding to the title of the 
     page. Thus, if we document the function f, there will be an anchor name called 'f'.<p>The sections of a manual are named via section numbers. Unfortunately, we do yet support
     sections with naming ids. Threfore the use the naming 'SECTION1', 'SECTION2', etc.<p>Finally, the top position, the position of the manual, the position before the table of contents,
     and the position before the manual index table are named with anchors. These are
     'MANUAL-TOP', 'MANUAL-TOP', and 'MANUAL-INDEX' respectively.")) ((kind "manual-page") (description "Define a manual section with title and body (plain text)
") (title "manual-section") (form (manual-section . elements))))